package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Activator;
import com.vendor.burn.Messages;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.devices.burners.Uploader;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.model.event.IFastbootEventListener;
import com.vendor.burn.serial.workers.WorkerUtility;
import com.vendor.burn.ui.BurnComposite;
import com.vendor.burn.utilitily.ToolUtils;
import java.io.File;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;

public class UploadCompsite extends BurnComposite implements IFastbootEventListener {
  private Text saveFileText;
  
  private Text uploadLen;
  
  private Button uploadButton;
  
  private Text uploadAddress;
  
  private Composite com;
  
  private Button browseButton;
  
  private TabItem tabItem;
  
  public UploadCompsite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
  }
  
  public Uploader getBurner() {
    IBurner burner = super.getBurner();
    if (burner instanceof Uploader)
      return (Uploader)burner; 
    return null;
  }
  
  protected void createContents(Composite parent) {
    parent.setLayout((Layout)new FillLayout());
    this.com = new Composite(parent, 0);
    this.com.setLayout((Layout)new GridLayout(1, true));
    GridData gridData = new GridData(1808);
    this.com.setLayoutData(gridData);
    Composite oneCom = new Composite(this.com, 0);
    Composite twoCom = new Composite(this.com, 0);
    Composite threeCom = new Composite(this.com, 0);
    Composite fourCom = new Composite(this.com, 0);
    GridLayout layout = new GridLayout(6, false);
    oneCom.setLayout((Layout)layout);
    layout = new GridLayout(10, false);
    layout.makeColumnsEqualWidth = true;
    twoCom.setLayout((Layout)layout);
    threeCom.setLayout((Layout)layout);
    fourCom.setLayout((Layout)layout);
    oneCom.setLayoutData(new GridData(4, 16777216, true, false, 1, 1));
    twoCom.setLayoutData(new GridData(4, 16777216, true, false, 1, 2));
    threeCom.setLayoutData(new GridData(4, 16777216, true, false, 1, 3));
    fourCom.setLayoutData(new GridData(4, 16777216, true, false, 1, 4));
    Label label = new Label(oneCom, 0);
    GridData layoutData = new GridData(1, 1, false, false);
    layoutData.horizontalIndent = 20;
    layoutData.widthHint = 100;
    label.setLayoutData(layoutData);
    label.setText(Messages.saveFile);
    this.saveFileText = new Text(oneCom, 2048);
    GridData tableFileTextGD = new GridData(4, 1, true, false);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.saveFileText.setLayoutData(tableFileTextGD);
    this.browseButton = new Button(oneCom, 0);
    this.browseButton.setImage(Activator.getImage("icons/selfile.ico"));
    layoutData = new GridData(1, 1, false, false);
    this.browseButton.setLayoutData(layoutData);
    ToolUtils.setWidthForOS(layoutData, 60, 70);
    this.browseButton.addListener(13, (Listener)new Object(this));
    createText(twoCom, threeCom);
    createButtons(fourCom);
  }
  
  private void createText(Composite twoCom, Composite threeCom) {
    Label label = new Label(twoCom, 0);
    GridData layoutData = new GridData(4, 16777216, false, false, 1, 1);
    layoutData.horizontalIndent = 20;
    layoutData.widthHint = 100;
    label.setLayoutData(layoutData);
    label.setText(Messages.flashReadAddress);
    this.uploadAddress = new Text(twoCom, 2048);
    GridData tableFileTextGD = new GridData(4, 16777216, false, true, 1, 2);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.uploadAddress.setLayoutData(tableFileTextGD);
    this.uploadAddress.addListener(14, (Listener)new Object(this));
    label = new Label(threeCom, 0);
    layoutData = new GridData(1, 16777216, false, true, 1, 1);
    layoutData.horizontalIndent = 20;
    layoutData.widthHint = 100;
    label.setLayoutData(layoutData);
    label.setText(Messages.readLength);
    this.uploadLen = new Text(threeCom, 2048);
    tableFileTextGD = new GridData(4, 16777216, false, true, 1, 2);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.uploadLen.setLayoutData(tableFileTextGD);
    label = new Label(threeCom, 0);
    layoutData = new GridData(4, 16777216, false, true, 1, 3);
    layoutData.horizontalIndent = 20;
    label.setLayoutData(layoutData);
    label.setText(Messages.unitByte);
  }
  
  private void handleLengthText() {
    if (this.uploadAddress == null || this.uploadAddress.isDisposed())
      return; 
    String text = this.uploadAddress.getText().trim();
    if (!text.startsWith("0x") && !text.startsWith("0X")) {
      this.uploadAddress.setText("");
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.pleaseInput16BurnAddress);
    } 
  }
  
  private void createButtons(Composite parent) {
    Label label = new Label(parent, 0);
    GridData layoutData = new GridData(4, 16777216, false, true, 1, 1);
    layoutData.horizontalIndent = 20;
    layoutData.widthHint = 100;
    label.setText("      ");
    label.setLayoutData(layoutData);
    this.uploadButton = new Button(parent, 0);
    this.uploadButton.setText(Messages.uploadImage);
    layoutData = new GridData(4, 16777216, false, true, 1, 2);
    layoutData.horizontalIndent = 5;
    layoutData.widthHint = 50;
    this.uploadButton.setLayoutData(layoutData);
    this.uploadButton.addListener(13, (Listener)new Object(this));
  }
  
  private void handleUploadEvent() {
    String path = this.saveFileText.getText().trim();
    if (path.isEmpty()) {
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.errSavePathNoBeEmpty);
      return;
    } 
    getBurner().setPath(path);
    String addressStr = this.uploadAddress.getText().trim();
    if (!addressStr.startsWith("0x") && !addressStr.startsWith("0X")) {
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.pleaseInput16BurnAddress);
      return;
    } 
    long address = WorkerUtility.ReceiveHelper.convertToNumber(addressStr);
    if (address == -1L) {
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.flashReadAddressOnlyNumber);
      return;
    } 
    getBurner().setAddress(address);
    String lengthStr = this.uploadLen.getText().trim();
    long len = WorkerUtility.ReceiveHelper.convertToNumber(lengthStr);
    if (len == -1L) {
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.readLengthOnlyNumber);
      return;
    } 
    if (len <= 0L) {
      MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.readLengthGreaterZero);
      return;
    } 
    getBurner().setLength(len);
    this.uploadButton.setEnabled(false);
    upload();
  }
  
  private void handleBrowseFile() {
    FileDialog dialog = new FileDialog(getShell(), 4096);
    dialog.setFilterExtensions(new String[] { "*" });
    String text = this.saveFileText.getText();
    if (!text.equals(""))
      dialog.setFileName(text); 
    String filePath = dialog.open();
    if (filePath != null) {
      File file = new File(filePath);
      int overwrite = 0;
      if (file.exists()) {
        MessageDialog dlg = new MessageDialog(getShell(), Messages.FASTBOOT_MessageDialog_Title, null, NLS.bind(Messages.PartitionComposite_msg_file_exists_already_whether_to_overwrite_it, filePath), 6, new String[] { IDialogConstants.YES_LABEL, IDialogConstants.NO_LABEL }, 0);
        overwrite = dlg.open();
      } 
      if (overwrite == 0)
        this.saveFileText.setText(filePath); 
    } 
  }
  
  public void setTabItem(TabItem tabItem) {
    this.tabItem = tabItem;
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(4, false);
  }
  
  public void finished(FastbootEvent event) {
    super.finished(event);
  }
  
  protected void enableUI() {
    enableButtons();
  }
  
  protected void enableButtons() {
    if (this.uploadButton != null && !this.uploadButton.isDisposed())
      this.uploadButton.setEnabled(true); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(true); 
  }
  
  protected void disableUI() {
    if (this.uploadButton != null && !this.uploadButton.isDisposed())
      this.uploadButton.setEnabled(false); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(false); 
  }
}
